<template>
  <rui-form v-if="resourceNote.resourceId"
            :errors="errors"
            :loading="loading"
            model="resource_note"
            @cancel="$emit('cancel')"
            @submit.prevent="save">
    <rui-field input-id="resource_note_content" :label="$t('activerecord.attributes.resource_note.content')">
      <textarea id="resource_note_content" v-model="inputs.content" name="content" />
    </rui-field>

    <rui-field :help="$t('js.resource_note.form.visible_help')">
      <label>
        <input v-model="inputs.visible" type="checkbox" name="visible">
        {{ $t('activerecord.attributes.resource_note.visible') }}
      </label>
    </rui-field>
  </rui-form>

  <rui-alert v-else variant="error">
    {{ $t('js.resource_note.form.missing_resource_id') }}
  </rui-alert>
</template>

<script>
import RuiAlert from '@experiments-labs/rise_ui/src/components/Alert/Alert.vue'
import RuiField from '@experiments-labs/rise_ui/src/components/Form/Field.vue'
import RuiForm from '@experiments-labs/rise_ui/src/components/Form/Form.vue'

import ResourceNote from '../../../../classes/models/ResourceNote'

export default {
  name: 'GpaResourceNoteForm',
  emits: [
    'cancel',
    'saved',
  ],
  components: { RuiAlert, RuiField, RuiForm },
  props: {
    resourceNote: { required: false, type: [ResourceNote, Object], default: () => ({}) },
  },
  data () {
    return {
      errors: null,
      loading: false,
      inputs: this.defaultInputs(),
    }
  },
  methods: {
    defaultInputs () {
      return {
        content: '' || this.$props.resourceNote.content,
        visible: this.resourceNote.visible !== false,
      }
    },
    save () {
      this.errors = null
      this.loading = false
      const payload = {
        id: this.$props.resourceNote.id,
        resource_id: this.$props.resourceNote.resourceId,
        content: this.inputs.content,
        visible: this.inputs.visible,
      }
      this.$store.dispatch('saveResourceNote', payload)
        .catch((errors) => { this.errors = errors })
        .then(() => {
          this.loading = false
          this.$emit('saved')
        })
    },
  },
  watch: {
    resourceNote () {
      this.inputs = this.defaultInputs()
    },
  },
}
</script>
